<template>
  <div>
    <Modal v-model="showSamplePrintedModal" width="1200" class="modal-footer-none">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <!--内容-->
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="formId" :label-width="80" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item label="样品名称:" class="search-item">
                <Input v-model="formObj.name" placeholder="请输入样品名称" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item label="样品编号:" class="search-item">
                <Input v-model="formObj.code" placeholder="请输入样品编号" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-btn" style="margin-left: -10px">
                <Button type="primary" @click="_formSearch">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide"
                      @on-result-change="_btnClick"></btn-list>
          </Col>
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :get-page="getPage"
                        :icon-msg="iconMsg" select-data @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <div v-if="item.detail"><a @click.stop="_detailModal(scope.row.id)">{{scope.row[item.key]}}</a></div>
                  <div v-else-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </div>
                  <div v-else-if="item.key==='jobOut'">
                    {{scope.row[item.key]===1?'是':'否'}}
                  </div>
                  <div v-else-if="item.key==='type'">
                      <span v-if="scope.row[item.key]===0">
                        检定
                      </span>
                    <span v-if="scope.row[item.key]===1">
                        校准
                      </span>
                    <span v-if="scope.row[item.key]===2">
                        外观检查
                     </span>
                  </div>
                  <div v-else>{{scope.row[item.key]}}</div>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </Modal>
    <operationModal ref="operationModal"></operationModal>
    <FileManage ref="FileManage"></FileManage>

    <!--编辑证书-->
    <CertificateMakeLook ref="itemOriginalRecordLookModal" @on-result-change="_resultRecord"></CertificateMakeLook>
  </div>

</template>
<script>
import { meterSample } from '../../../api'
import operationModal from '../../../components/operation/Operation'
import CertificateMakeLook from '../../meter-certificate/CertificateMakeLook'
import http from '../../../api/http'
export default {
  components: { operationModal, CertificateMakeLook },
  data() {
    return {
      currentComponent: '',
      formId: 'meterCertificatePrintIndexFormId',
      searchOpen: true,
      showSamplePrintedModal: false,
      btn: [
        {
          type: 'success',
          id: '',
          name: '导出证书记录'
        }
      ],
      iconMsg: [
        // {
        //   type: 'ios-book',
        //   id: '',
        //   name: '查看证书'
        // },
        {
          type: 'ios-book',
          id: '',
          name: '在线查看证书'
        },
        { type: 'md-cloud', id: '', name: '附件' }
      ],
      formObj: {
        client: undefined,
        entrustId: undefined,
        entrustCode: undefined
      },
      selectIds: [],
      selectData: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '委托编号', key: 'entrustCode', width: 130 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '样品名称', key: 'name', width: 120 },
        { title: '样品编号', key: 'code', width: 145 },
        { title: '证书编号', key: 'reportCode', width: 145 },
        { title: '证书编制人', key: 'reportMaker', width: 145 },
        {
          title: '证书编制时间',
          key: 'reportMakeTime',
          width: 145,
          date: true
        },
        { title: '证书审核人', key: 'reportChecker', width: 145 },
        {
          title: '证书审核时间',
          key: 'reportCheckTime',
          width: 145,
          date: true
        },
        { title: '证书签发人', key: 'reportIssuer', width: 145 },
        {
          title: '证书签发时间',
          key: 'reportIssueTime',
          width: 145,
          date: true
        },
        { title: '型号规格', key: 'spec', width: 100 },
        { title: '出厂编号', key: 'factoryNumber' },
        { title: '检测类型', key: 'type', width: 100 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '数量', key: 'quantity' },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '生成':
            this._create()
            break
          case '添加':
            this._editModal(false)
            break
          case '导出证书记录':
            this._exportCertificateInfo()
            break
          case '退回':
            this._goBack()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _open(id) {
      this.formObj.entrustId = id
      this.showSamplePrintedModal = true
      this._page()
    },
    _exportCertificateInfo() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择要导出的数据!')
        return false
      }
      const sampleIds = this.selectIds.join(',')
      const data = this.formObj
      data.idsStr = sampleIds
      this.$Modal.confirm({
        title: '提示',
        content: '确定导出数据？',
        onOk: () => {
          http.open(
            '/meter/v1/sample/export_certificate_info/?ids=' + sampleIds
          )
        }
      })
    },

    _submitToReview() {
      this._submitByContractIds()
    },
    _printExcel() {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$pageofficePrint({ ids: ids, type: 'xlsx' })
      }
    },

    _submitEnd: async function(data) {
      const result = await meterSample.endReport(data)
      if (result) {
        this.$Message.success('提交成功！')
        await this._page()
      }
    },

    _create() {
      const selectData = JSON.parse(JSON.stringify(this.selectData))
      console.log(selectData)
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.CreateReport._open(this.selectData)
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '预览':
            // this._editModal(true, data.id)
            this._personModal(data)
            break
          case '附件':
            this._upload(data.id)
            break
          case '查看证书':
            this._itemOriginalRecordLook(data, 'only')
            break
          case '在线查看证书':
            this._reportMakeLook(data)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _reportMakeLook: async function(data) {
      const result = await meterSample.getCertificateReport(data.id)
      if (result) {
        this._viewReport(result)
      } else {
        this._itemOriginalRecordLook(data, 'only')
      }
    },
    _viewReport(data) {
      if (data) {
        this.$openWindowModeless({
          objectKey: data.objectKey,
          idType: 10,
          id: data.id,
          isReport: 5
        })
      }
    },
    _personModal(data) {
      this._previewEdit(data.id)
    },
    // 预览编辑
    async _previewEdit(id) {
      const result = await meterSample.reportPreview(id)
      if (result) {
        this.$openWindowModeless({
          objectKey: result.objectKey,
          id: id,
          isReport: 0
        })
      }
    },
    _record(id) {
      this.$refs.operationModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          console.log('操作按钮点击后的值', data)
          break
        // case 'selectIds':
        //   this.selectIds = data
        //   console.log('操作按钮点击后的值', data)
        //   break
        case 'selectData':
          this.selectData = data
          this.selectIds = []
          for (let i = 0; i < data.length; i++) {
            this.selectIds.push(data[i].id)
          }
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await meterSample.pageCertificatePrinted(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _itemOriginalRecordLook(data, name) {
      if (
        data.recordId === null ||
        undefined === data.recordId ||
        data.recordId === ''
      ) {
        this.$Message.warning('证书暂未编制！')
      } else {
        this.$refs.itemOriginalRecordLookModal._open(
          data.recordId,
          name,
          data.id
        )
      }
    },
    _resultRecord() {},
    _getById: async function(id) {
      const result = await meterSample.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._openEdit(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSample.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
